
// ClientSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ClientSample.h"
#include "ClientSampleDlg.h"
#include "Tlhelp32.h"	// CreateToolhelp32Snapshot

static HWND	m_hNotepad = NULL;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CClientSampleDlg dialog




CClientSampleDlg::CClientSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClientSampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClientSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_CONSOLE, m_Edit_Console);
	DDX_Control(pDX, IDC_BUTTON_LISTEN, m_Button_Connect);
	DDX_Control(pDX, IDC_BUTTON_DISCONNECT, m_Button_Disconnect);
	DDX_Control(pDX, IDC_BUTTON_SEND, m_Button_Send);
	DDX_Control(pDX, IDC_EDIT_PORT, m_Edit_Port);
	DDX_Control(pDX, IDC_EDIT_SEND, m_Edit_Send);
	DDX_Control(pDX, IDC_CHECK_CR, m_Check_CR);
	DDX_Control(pDX, IDC_CHECK_LF, m_Check_LF);
	DDX_Control(pDX, IDC_IPADDRESS1, m_Remote_IP);
}

BEGIN_MESSAGE_MAP(CClientSampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, &CClientSampleDlg::OnBnClickedButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CClientSampleDlg::OnBnClickedButtonSend)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, &CClientSampleDlg::OnBnClickedButtonConnect)
END_MESSAGE_MAP()


// CClientSampleDlg message handlers

BOOL CClientSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_Edit_Port.SetLimitText(5);
	SetDlgItemInt(IDC_EDIT_PORT, 1470);

	m_Button_Disconnect.EnableWindow(FALSE);	
	m_Button_Send.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClientSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClientSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClientSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CClientSampleDlg::SocketClose(int nErrorCode)
{
	m_ClientSocket.Close();
	m_Edit_Console.ReplaceSel(_T("Connection closed.\r\n"));

	m_Button_Connect.EnableWindow(TRUE);
	m_Button_Disconnect.EnableWindow(FALSE);
	m_Button_Send.EnableWindow(FALSE);
}

void CClientSampleDlg::Receive(int nErrorCode)
{
	int len, count;
	CString strMsg;
	BYTE buf[1024];

	memset(&buf, 0x00, sizeof(buf));

	len = m_ClientSocket.Receive(buf, 1024, 0);

	for(count = 0; count < len; count++)
	{
		strMsg.Format("%c", buf[count]);
		m_Edit_Console.ReplaceSel(strMsg);
	}

	// 2011-02-24    By Jae-Hong Lee 
	//  ͸ ޸忡 ´.
	CString strText;
	strText.Format(_T("%s"), buf);
	Dump2Notepad(strText);
}

void CClientSampleDlg::OnBnClickedButtonDisconnect()
{
	// TODO: Add your control notification handler code here
	m_ClientSocket.Close();

	m_Edit_Console.ReplaceSel("Close connection.\r\n");

	m_Button_Connect.EnableWindow(TRUE);
	m_Button_Disconnect.EnableWindow(FALSE);
	m_Button_Send.EnableWindow(FALSE);
}

void CClientSampleDlg::OnBnClickedButtonSend()
{
	// TODO: Add your control notification handler code here
	char buf[128];
	memset(&buf, 0x00, sizeof(buf));

	CString strMsg;
	m_Edit_Send.GetWindowText(strMsg);

	m_ClientSocket.Send(strMsg, strMsg.GetLength(), 0);

	if(m_Check_CR.GetCheck())
	{
		buf[0] = 0x0d;
		m_ClientSocket.Send(buf, 1 ,0);
	}

	if(m_Check_LF.GetCheck())
	{
		buf[0] = 0x0a;
		m_ClientSocket.Send(buf, 1 ,0);
	}
}

void CClientSampleDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	m_ClientSocket.Close();
}

void CClientSampleDlg::OnBnClickedButtonConnect()
{
	// TODO: Add your control notification handler code here
	CString strIP, strMsg;
	UINT nPort;

	m_ClientSocket.Create(0, SOCK_STREAM);

	m_Remote_IP.GetWindowText(strIP);
	nPort = GetDlgItemInt(IDC_EDIT_PORT);

	m_ClientSocket.Connect(strIP, nPort);

	m_Button_Connect.EnableWindow(FALSE);
	m_Button_Disconnect.EnableWindow(TRUE);

	strMsg.Format(_T("Connect to %s(%u)...."), strIP, nPort);
	m_Edit_Console.ReplaceSel(strMsg);
}

// Callback functions
void CClientSampleDlg::Connect(int nErrorCode)
{
	if(nErrorCode)
	{
		m_ClientSocket.Close();
		m_Edit_Console.ReplaceSel("Connect fail.\r\n");
		m_Button_Connect.EnableWindow(TRUE);
		m_Button_Disconnect.EnableWindow(FALSE);
	}
	else
	{
		m_Edit_Console.ReplaceSel("Connected.\r\n");
		m_Button_Send.EnableWindow(TRUE);
	}
}

BOOL CALLBACK EnumProcNotepad(HWND hwnd, LPARAM lParam)
{
	DWORD processID;
	DWORD processID2 = (DWORD)lParam;
	::GetWindowThreadProcessId(hwnd, &processID);
	if (processID == processID2)
	{   
		// μ ڵ.
		//μ ڵ  ¿ ֻ θ츦 ã´.
		HWND hParent = hwnd;
		do
		{
			hwnd = hParent;
			hParent = ::GetWindow(hParent, GW_OWNER);
			::GetWindowThreadProcessId(hParent, &processID);
		} while (hParent && processID == processID2);

		if (::IsWindowVisible(hwnd))
		{ 
			//ش 찡 밡  ˻Ѵ.
			m_hNotepad = hwnd;
			return FALSE; //۾ Ѵ.
		}
	}
	return TRUE;
}

void CClientSampleDlg::Dump2Notepad(LPCTSTR fmt, ...)
{
	//-------------------------------------------------------------------
	//NotePAD ã´.
	for (int T=0; T<2; T++)
	{
		if (m_hNotepad == NULL || !IsWindow(m_hNotepad))
		{
			HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPALL, 0);
			if (hSnapshot != (HANDLE)(-1))
			{
				// μ   μID ȹѴ.
				PROCESSENTRY32 Process;
				Process.dwSize = sizeof(PROCESSENTRY32);
				if (Process32First(hSnapshot, &Process))
				{
					do
					{
						CString strFileName = Process.szExeFile;
						if(_tcscmp(Process.szExeFile, _T("notepad.exe")) == 0)
						{
							::EnumWindows(EnumProcNotepad, (LPARAM)Process.th32ProcessID);
						}
					} while (Process32Next(hSnapshot, &Process));
				}
				CloseHandle(hSnapshot);
			}
		}

		//NotePAD ã   NotePAD Ų.
		if (m_hNotepad == NULL || !IsWindow(m_hNotepad))
		{
			::ShellExecute(NULL, NULL, _T("notepad.exe"), NULL, NULL, SW_SHOWNORMAL);
			Sleep(100); //NotePAD   ִ ð ش.
		}
		else 
			break;
	}

	if (m_hNotepad == NULL || !IsWindow(m_hNotepad)) 
		return; // ó

	TCHAR buffer[4096]={0};
	va_list argptr;
	va_start(argptr, fmt);
	_vstprintf(buffer, fmt, argptr);
	va_end(argptr);
	_tcscat(buffer, _T("\r\n"));

	//NotePAD  â ã´.
	//NotePAD  ù° ڽ  â̴.(SPY++ Ȯ )
	HWND hWnd = ::GetWindow(m_hNotepad, GW_CHILD);

	//NotePAD ϴ Ŀ ġ ̵
	::SendMessage(hWnd, EM_SETSEL,(DWORD)0,(DWORD)-1);
	::SendMessage(hWnd, EM_SETSEL,(DWORD)-1,(DWORD)0);
	// 
	::SendMessage(hWnd, EM_REPLACESEL, 0, (LPARAM)buffer);
}

